## ros-foxy-rviz-visual-tools 4.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(rviz_visual_tools)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-W -Wall -Wextra
    -Wwrite-strings -Wunreachable-code -Wpointer-arith
    -Winit-self -Wredundant-decls
    -Wno-unused-parameter -Wno-unused-function)
endif()

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(rviz_ogre_vendor REQUIRED)

find_package(sensor_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(shape_msgs REQUIRED)
find_package(visualization_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(trajectory_msgs REQUIRED)

find_package(eigen3_cmake_module REQUIRED)
find_package(eigen_stl_containers REQUIRED)
find_package(Eigen3 REQUIRED)

find_package(PkgConfig REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_eigen REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)

find_package(pluginlib REQUIRED)
find_package(interactive_markers REQUIRED)
find_package(rviz_common REQUIRED)
find_package(rviz_rendering REQUIRED)
find_package(rviz_default_plugins REQUIRED)

find_package(Qt5 REQUIRED COMPONENTS Widgets)

## Qt5 boilerplate options from http://doc.qt.io/qt-5/cmake-manual.html
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

## Prefer the Qt signals and slots to avoid defining "emit", "slots",
## etc because they can conflict with boost signals, so define QT_NO_KEYWORDS here.
set(CMAKE_AUTOMOC_COMPILER_PREDEFINES OFF)
add_definitions(-DQT_NO_KEYWORDS)

###########
## Build ##
###########

# Needed for shared libraries on Windows
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
if(NOT DEFINED BUILD_SHARED_LIBS)
  option(BUILD_SHARED_LIBS "Build dynamically-linked binaries" ON)
endif()

# Rviz GUI library
 set(SOURCE_FILES
   src/${PROJECT_NAME}_gui.cpp
   src/key_tool.cpp
   src/remote_control.cpp
 )
set(HEADER_FILES
    include/${PROJECT_NAME}/${PROJECT_NAME}_gui.hpp
    include/${PROJECT_NAME}/key_tool.hpp
    include/${PROJECT_NAME}/remote_control.hpp
    include/${PROJECT_NAME}/remote_reciever.hpp
    )

add_library(${PROJECT_NAME}_gui SHARED ${SOURCE_FILES} ${HEADER_FILES})
ament_target_dependencies(${PROJECT_NAME}_gui
        rclcpp
        rviz_common
        rviz_rendering
        rviz_default_plugins
        )
target_include_directories(${PROJECT_NAME}_gui PUBLIC
   include
   ${OGRE_INCLUDE_DIRS}
   ${rviz_rendering_INCLUDE_DIRS}
   ${rviz_common_INCLUDE_DIRS}
   ${rviz_default_plugins_INCLUDE_DIRS}
)
target_link_libraries(${PROJECT_NAME}_gui Qt5::Widgets)
# prevent pluginlib from using boost
target_compile_definitions(${PROJECT_NAME}_gui PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
## Causes the visibility macros to use dllexport rather than dllimport (for Windows, when your plugin should be used as library)
#target_compile_definitions(${PROJECT_NAME}_gui PRIVATE "RVIZ_DEFAULT_PLUGINS_BUILDING_LIBRARY")
pluginlib_export_plugin_description_file(rviz_common plugin_description.xml)

add_library(${PROJECT_NAME}_remote_control SHARED
  src/remote_control.cpp
)
# Needed for M_PI on Windows
target_compile_definitions(${PROJECT_NAME}_remote_control PRIVATE _USE_MATH_DEFINES)
target_include_directories(${PROJECT_NAME}_remote_control
  PUBLIC
    include
)
ament_target_dependencies(${PROJECT_NAME}_remote_control
  rclcpp
  rclcpp_components
  visualization_msgs
  tf2
  tf2_eigen
  tf2_geometry_msgs
  sensor_msgs
  shape_msgs
  std_msgs
  trajectory_msgs
  eigen_stl_containers
)

# Visualization Tools Library
add_library(${PROJECT_NAME} SHARED
  src/rviz_visual_tools.cpp
  src/tf_visual_tools.cpp
)
target_compile_definitions(${PROJECT_NAME} PRIVATE _USE_MATH_DEFINES)
target_include_directories(${PROJECT_NAME}
  PUBLIC
    include
    ${Eigen3_INCLUDE_DIRS}
)
target_link_libraries(${PROJECT_NAME}
  ${PROJECT_NAME}_remote_control
)
ament_target_dependencies(${PROJECT_NAME}
  rclcpp
  rclcpp_components
  visualization_msgs
  tf2
  tf2_eigen
  tf2_geometry_msgs
  sensor_msgs
  shape_msgs
  std_msgs
  trajectory_msgs
  eigen_stl_containers
)

# Library
add_library(${PROJECT_NAME}_imarker_simple
  src/imarker_simple.cpp
)
target_compile_definitions(${PROJECT_NAME}_imarker_simple PRIVATE _USE_MATH_DEFINES)
target_include_directories(${PROJECT_NAME}_imarker_simple
  PUBLIC
    include
    ${Eigen3_INCLUDE_DIRS}
)
target_link_libraries(${PROJECT_NAME}_imarker_simple
  ${PROJECT_NAME}
)
ament_target_dependencies(${PROJECT_NAME}_imarker_simple
  rclcpp
  interactive_markers
  geometry_msgs
  visualization_msgs
  sensor_msgs
  eigen_stl_containers
)

# Demo executable
add_executable(${PROJECT_NAME}_demo
  src/${PROJECT_NAME}_demo.cpp
)
target_compile_definitions(${PROJECT_NAME}_demo PRIVATE _USE_MATH_DEFINES)
target_link_libraries(${PROJECT_NAME}_demo
  ${PROJECT_NAME}
)
ament_target_dependencies(${PROJECT_NAME}_demo
  rclcpp
  geometry_msgs
  std_msgs
)

# Demo executable
add_executable(${PROJECT_NAME}_imarker_simple_demo
  src/imarker_simple_demo.cpp)
target_compile_definitions(${PROJECT_NAME}_imarker_simple_demo PRIVATE _USE_MATH_DEFINES)
target_link_libraries(${PROJECT_NAME}_imarker_simple_demo
  ${PROJECT_NAME}_imarker_simple
)
ament_target_dependencies(${PROJECT_NAME}_imarker_simple_demo
  rclcpp
)

#############
## Install ##
#############
# Install libraries
install(
  TARGETS
    ${PROJECT_NAME}
    ${PROJECT_NAME}_remote_control
    ${PROJECT_NAME}_gui
    ${PROJECT_NAME}_imarker_simple
  EXPORT
    ${PROJECT_NAME}
    #${PROJECT_NAME}_gui
    # ${PROJECT_NAME}_imarker_simple
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# Install executables
install(
  TARGETS
    ${PROJECT_NAME}_demo
    ${PROJECT_NAME}_imarker_simple_demo
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

# Install header files
install(
  DIRECTORY include/
  DESTINATION include)

# Install shared resources
install(DIRECTORY launch    DESTINATION share/${PROJECT_NAME})

ament_export_dependencies(geometry_msgs
  shape_msgs
  rclcpp
  sensor_msgs
  std_msgs
  trajectory_msgs
  visualization_msgs
  eigen3_cmake_module
  Eigen3
  eigen_stl_containers
  interactive_markers
  rviz_common
  rviz_rendering
  rviz_default_plugins
)
ament_export_include_directories(include)
ament_export_libraries(
  ${PROJECT_NAME}
  ${PROJECT_NAME}_remote_control
  ${PROJECT_NAME}_imarker_simple
  ${PROJECT_NAME}_gui
)

##########
## TEST ##
##########
if (BUILD_TESTING)
  # Run tests
  find_package(ament_cmake_gtest REQUIRED)
  ament_add_gtest(${PROJECT_NAME}_rvt_test
    tests/rvt_test.cpp
    TIMEOUT 180)
  target_compile_definitions(${PROJECT_NAME}_rvt_test PRIVATE _USE_MATH_DEFINES)
  ament_target_dependencies(${PROJECT_NAME}_rvt_test
    rclcpp
  )
  target_link_libraries(${PROJECT_NAME}_rvt_test
    ${PROJECT_NAME}
  )
endif()

ament_package()

=== debian/changelog ===
ros-foxy-rviz-visual-tools (4.0.3-1focal) focal; urgency=high

  * Make sure to add all dependencies to the package.xml (#209 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/209>) (#214 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/214>)
  * Backport Fix faulty templated constructor (#213 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/213>)
  * Contributors: Vatan Aksoy Tezer, Chris Lalancette

 -- Mike Lautman <mike@picknik.ai>  Sun, 12 Dec 2021 21:00:00 -0000

ros-foxy-rviz-visual-tools (4.0.2-1focal) focal; urgency=high

  * Add pluginlib dependency. (#203 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/203>)
  * Re-enable RemoteControl functionality (#204 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/204>)
    * use condition_variable to be more thread safe
    * Drop executor from constructor, deprecate old one
    * Fix RemoteControl usage in demo
    * Use SystemDefaultsQOS for RemoteControl subscriber
    * Add RvizVisualToolsGui dashboard to rviz config, correct view
  * Rename node_executable to executable (#201 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/201>)
  * Contributors: Davide Faconti, Henning Kayser, Jafar Abdi, Steven! Ragnarök, Vatan Aksoy Tezer

 -- Mike Lautman <mike@picknik.ai>  Wed, 06 Oct 2021 21:00:00 -0000

ros-foxy-rviz-visual-tools (4.0.1-1focal) focal; urgency=high

  * Remove executor namespace from rclcpp (#190 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/190>)
  * Fixes & improvements for deleting markers (#188 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/188>)
    * Added RvizVisualTools method to delete all markers in a namespace
    * Fixed deleteAllMarkers for all namespaces
    * Added getters for marker ID's
  * Move waitForSubscriber function to header file (#185 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/185>)
  * Create LICENSE (#183 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/183>)
  * Contributors: Jafar Abdi, Nathan Brooks, Vatan Aksoy Tezer, Wyatt Rees

 -- Mike Lautman <mike@picknik.ai>  Mon, 13 Sep 2021 21:00:00 -0000

ros-foxy-rviz-visual-tools (4.0.0-1focal) focal; urgency=high

  * Fix warning about deprecation (#180 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/180>)
    rclcpp::executor::FutureReturnCode was removed
  * Update to offer shared_ptr to create_timer
  * Fix rviz_visual_tools_gui (#147 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/147>)
  * Compilation for Windows (#143 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/143>)
  * Remove stl file in preparation for LFS setup (#140 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/140>)
  * Add function deleteMarker: deletes marker for given namespace and id (#137 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/137>)
  * fix waitForSubscriber time (#142 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/142>)
  * Eloquent cleanup (#135 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/135>)
    * some misc cleanup of the imarker simple lib
    * actually reset marker counts
    * changes for using IMarker simple as a library
  * Fix rviz warnings about scale and uninitialized quaternions (#129 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/129>)
  * Normalize interactive marker quaternions. (#132 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/132>)
  * normalize before publish (#131 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/131>)
  * New helper function getIdentityPose() (#122 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/122>)
  * For ABCD planes: better comments, ensure the plane equation is satisfied. (#120 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/120>)
    Co-Authored-By: Henning Kayser <mailto:henningkayser@picknik.ai>
  * Make rviz_visual_tools publish triangle mesh and tf_visual_tools clean published transforms (#117 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/117>)
    * Add clearAllTransform method to tf_visual_tools
    * Add new function to publish mesh marker from triangles and vertices
  * Publish plane from Ax+By+Cz+D=0 equation (#119 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/119>)
  * Fixed publishCylinder namespace (#109 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/109>)
  * Remove default arguments to make function calls not ambiguous (#112 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/112>)
  * Initialize quaternions in demo to avoid warning (#111 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/111>)
  * Fix node type in demo launch files (#110 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/110>)
  * Use LOGNAME for logging re:moveit styel (#106 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/106>)
  * Contributors: AndyZe, Bjar Ne, Dave Coleman, Jafar Abdi, Mike Lautman, Mori, MoriKen, Nathan Brooks, Sean Yen, Victor Lamoine, Yu Yan, d-walsh, hshose

 -- Mike Lautman <mike@picknik.ai>  Thu, 08 Apr 2021 21:00:00 -0000

ros-foxy-rviz-visual-tools (3.7.0-1focal) focal; urgency=high

  * Fix Eigen::Affine3d for Melodic (using Eigen::Isometry3d) (#105 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/105>)
  * Improve documentation (#100 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/100>)
  * Fix some catkin_lint warnings and rename targets output (#98 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/98>)
  * Update README Kinetic to Melodic (#102 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/102>)
  * Add Melodic build farm badges (#99 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/99>)
  * Add ccache support (#93 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/93>)
  * no ros::spinOnce() (#82 <https://github.com/PickNikRobotics/rviz_visual_tools/issues/82>)


=== debian/control ===
Source: ros-foxy-rviz-visual-tools
Section: misc
Priority: optional
Maintainer: Mike Lautman <mike@picknik.ai>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libqt5x11extras5-dev, qtbase5-dev, ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-eigen-stl-containers, ros-foxy-eigen3-cmake-module, ros-foxy-geometry-msgs, ros-foxy-interactive-markers, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rviz-common, ros-foxy-rviz-default-plugins, ros-foxy-rviz-ogre-vendor, ros-foxy-rviz-rendering, ros-foxy-sensor-msgs, ros-foxy-shape-msgs, ros-foxy-std-msgs, ros-foxy-tf2, ros-foxy-tf2-eigen, ros-foxy-tf2-geometry-msgs, ros-foxy-trajectory-msgs, ros-foxy-visualization-msgs, ros-foxy-ros-workspace
Homepage: https://github.com/PickNikRobotics/rviz_visual_tools
Standards-Version: 3.9.2

Package: ros-foxy-rviz-visual-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libqt5widgets5, libqt5x11extras5-dev, ros-foxy-ament-index-python, ros-foxy-eigen-stl-containers, ros-foxy-eigen3-cmake-module, ros-foxy-geometry-msgs, ros-foxy-interactive-markers, ros-foxy-launch, ros-foxy-launch-ros, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-rviz-common, ros-foxy-rviz-default-plugins, ros-foxy-rviz-ogre-vendor, ros-foxy-rviz-rendering, ros-foxy-rviz2, ros-foxy-sensor-msgs, ros-foxy-shape-msgs, ros-foxy-std-msgs, ros-foxy-tf2, ros-foxy-tf2-eigen, ros-foxy-tf2-geometry-msgs, ros-foxy-trajectory-msgs, ros-foxy-visualization-msgs, ros-foxy-ros-workspace
Description: Utility functions for displaying and debugging data in Rviz via published markers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rviz-visual-tools//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
